function [k theta  rhotd omegatd scaling] = HSMM(lambda,trceTime,timeInt,trce)
%%%%%% HSMM algorithm %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%Loop through all entries in the time list
%%% Mark them as lost, received or missed
%%% iterate through all the missed entries
%%% compute the likelihood for each possible outcome
%%% using the  modified backward and forward algorithm

maxTime=trceTime(length(trceTime))-trceTime(1);
timeArray = trceTime(1) + [0:timeInt:(maxTime+timeInt)];

binArray=(-1)*ones(1,length(timeArray));
for t=2:length(timeArray)
    tempk=find((trceTime>=timeArray(t-1))&(trceTime<timeArray(t)));
    if length(tempk)>0
        binArray(t) = trce(tempk(1));
    end
end
%%%% Forward and backward algotihm
%%%%% Algo
%%%% Buiid an array rhotd1, rhotd0 of size n+m
%%%%%

%%innitialize
[L NL]= LNL(trce);
EL=mean(L);
ENL=mean(NL);
%%%innitialize
k=[20 1];
if (var(L)>0)
    k(1)=EL^2/(var(L));
end
if (var(NL)>0)
    k(2)=ENL^2/(var(NL));
end

k
theta=(1/(lambda))*[EL/k(1) ENL/k(2)]

iterNr=0;

likelihood = -1;%log(sum(alpha(:,length(timeArray))));
likelihoodold=-10;
piArray=[0.5 0.5];

%%% stopping criteria
%while (abs(theta(1)-thetaold(1))>0.1)|| (abs(theta(2)-thetaold(2))>0.1)
while (((likelihood-likelihoodold>0.001*abs(likelihoodold))&& (iterNr<40))||(iterNr==1))  

    tic
    iterNr=iterNr+1

    thetaold=theta;
    kold=k;

    likelihoodold=likelihood;

    alpha=ones(2,length(timeArray)+1);
    
    %%%% How many look-ahead should I do
    %%%% for each time point
    limit =zeros(2,length(timeArray)); 

    %%%Rho
    rhotd=zeros(2,length(timeArray)+1, 1000);
    rhotd(1,1,1)=mean(L)/(mean(L)+mean(NL));
    rhotd(2,1,1)=mean(NL)/(mean(L)+mean(NL));

    scaling =ones(1,length(timeArray));

    for i=2:size(rhotd,2)
        alpha(1,i)= 0;
        alpha(2,i)= 0;
        %%%%scaling

        if (binArray(i-1)>=0)&&(sum(alpha(:,i-1))>0)
            scaling(i-1) = 1/sum(alpha(:,i-1));
        end

        if binArray(i-1) == 0
            for j=2:i
                rhotd(1,i,j)= scaling(i-1)*isequal(binArray(i-1),0)*rhotd(1,i-1,j-1);
                alpha(1,i) = alpha(1,i)+rhotd(1,i,j)*distF(theta(1),k(1),(j-1),lambda); %%% theta,k,n
                if i>j
                    if isequal(binArray((i-1) - (j-1)),1)
                        break
                    end
                end

            end
        elseif binArray(i-1) == 1
            for j=2:i
                rhotd(2,i,j)= scaling(i-1)*isequal(binArray(i-1),1)*rhotd(2,i-1,j-1);
                alpha(2,i) = alpha(2,i)+rhotd(2,i,j)*distF(theta(2),k(2),(j-1),lambda); %%% theta,k,n
                if i>j
                    if isequal(binArray((i-1) - (j-1)),0)
                        break
                    end
                end
            end
        else
            for idx=1:1:2
                if idx ==1
                    for j=2:i
                        rhotd(1,i,j)= rhotd(1,i-1,j-1);
                        alpha(1,i) = alpha(1,i)+rhotd(1,i,j)*distF(theta(1),k(1),(j-1),lambda);
                        if i>j
                            if isequal(binArray((i-1) - (j-1)),1)
                                break
                            end
                        end
                    end
                else
                    for j=2:i-1
                        rhotd(2,i,j)= rhotd(2,i-1,j-1);
                        alpha(2,i) = alpha(2,i)+rhotd(2,i,j)*distF(theta(2),k(2),(j-1),lambda);
                        if i>j
                            if isequal(binArray((i-1) - (j-1)),0)
                                break
                            end
                        end
                    end
                end
            end
        end
        rhotd(1,i,1)=alpha(2,i);
        rhotd(2,i,1)=alpha(1,i);
    end

    %%omega
    omegatd=zeros(2,length(timeArray)+1,1000);
    omegatd(:,length(timeArray)+1,1)=1;
    beta = ones(2,length(timeArray)+1);
    for i=2:size(rhotd,2)
        iinv=length(timeArray)+2 -i;
        beta(1,iinv)=0;
        beta(2,iinv)=0;
        if binArray(iinv) == 0
            for j=2:length(timeArray)
                omegatd(1,iinv,j)= scaling(iinv)*isequal(binArray(iinv),0)*omegatd(1,iinv+1,j-1); %%%% Be very careful here!!!! scaling(iinv) or scaling(iinv+1)
                beta(1,iinv) = beta(1,iinv)+omegatd(1,iinv,j)*distF(theta(1),k(1),(j-1),lambda); %%% theta,k,n
                if iinv + j-1 <= length(timeArray)
                    if isequal(binArray((iinv) + (j-1)),1)
                        break
                    end
                else
                    break
                end
            end
            limit(1,iinv) = j;
        elseif binArray(iinv) == 1
            for j=2:length(timeArray)
                omegatd(2,iinv,j)= scaling(iinv)*isequal(binArray(iinv),1)*omegatd(2,iinv+1,j-1);
                beta(2,iinv) = beta(2,iinv)+omegatd(2,iinv,j)*distF(theta(2),k(2),(j-1),lambda);
                if iinv + j-1 <= length(timeArray)
                    if isequal(binArray((iinv) + (j-1)),0)
                        break
                    end
                else
                    break
                end
            end
            limit(2,iinv) = j;
        else
            %%%%% How much should I travel back in time ???????????
            for idx=1:2
                if idx == 1
                    for j=2:length(timeArray)
                        omegatd(1,iinv,j)= omegatd(1,iinv+1,j-1);
                        beta(1,iinv) = beta(1,iinv)+omegatd(1,iinv,j)*distF(theta(1),k(1),(j-1),lambda);

                        if iinv + j -1<= length(timeArray)
                            if isequal(binArray((iinv) + (j-1)),1)
                                break
                            end
                        else
                            break
                        end
                    end
                   limit(1,iinv) = j;
                else
                    for j=2:length(timeArray)
                        omegatd(2,iinv,j)= omegatd(2,iinv+1,j-1);
                        beta(2,iinv) = beta(2,iinv)+omegatd(2,iinv,j)*distF(theta(2),k(2),(j-1),lambda);
                        if iinv + j -1 <= length(timeArray)
                            if isequal(binArray((iinv) + (j-1)),0)
                                break
                            end
                        else
                            break
                        end
                    end
                    limit(2,iinv) = j;
                end
            end
        end
        omegatd(1,iinv,1)=beta(2,iinv);
        omegatd(2,iinv,1)=beta(1,iinv);
    end

    toc
    
    k1array=[0.01:0.01:20];
    %%%k1array=[1];
    diffarray1=[];
    k2array=[0.01:0.01:20];
    %%%%k2array=[1];
    diffarray2=[];
    theta2array=[];
    theta1array=[];

    nume1=0;
    deno1=0;
    deno2=0;
    nume2=0;
    numek1=0;
    denok1=0;
    denok2=0;
    numek2=0;

    for i=3:size(omegatd,2)+1 %%%% Be very careful here !!!!!!!
        for idx=1:1:2
            if idx ==1
                for j=2:limit(1,i-2)
                    nume1=nume1+(j-1)*rhotd(1,i-2,1)*distF(theta(1),k(1),(j-1),lambda)*omegatd(1,i-2,j); %%%% careful j-1 or j????? Answer j                                   
                    numek1=numek1+log((j-1)/theta(1))*rhotd(1,i-2,1)*distF(theta(1),k(1),(j-1),lambda)*omegatd(1,i-2,j);
                end
            else
                for j=2:limit(2,i-2)
                    nume2=nume2+(j-1)*rhotd(2,i-2,1)*distF(theta(2),k(2),(j-1),lambda)*omegatd(2,i-2,j);             
                    numek2=numek2+ log((j-1)/theta(2))*rhotd(2,i-2,1)*distF(theta(2),k(2),(j-1),lambda)*omegatd(2,i-2,j);
                end              
            end
        end

        deno1=deno1+rhotd(1,i-2,1)*beta(1,i-2);
        deno2=deno2+rhotd(2,i-2,1)*beta(2,i-2);
        denok1=denok1+rhotd(1,i-2,1)*beta(1,i-2);
        denok2=denok2+rhotd(2,i-2,1)*beta(2,i-2);
    end
    toc
 
    %%%%%% Numercial search %%%%%%%%
    for kidx=1:length(k1array)
        k(1)=k1array(kidx);
        k(2)=k2array(kidx);
        %theta(1)= nume1/(k(1)*deno1);
        %theta(2)= nume2/(k(2)*deno2);
        diffarray1=[diffarray1 abs(numek1/denok1-psi(k(1)))];
        diffarray2=[diffarray2 abs(numek2/denok2-psi(k(2)))];

    end

    [mink1 k1]=min(diffarray1);
    k(1)=k1array(k1(1));

    [mink2 k2]=min(diffarray2);
    k(2)=k2array(k2(1));
    % %
    % %         %%%%%%% Newton Method %%%%%%%%
    % %             k(1) = timeInt*nume1/(theta(1)*deno1);
    % %             k(2) = timeInt*nume2/(theta(2)*deno2);
    % %             kold=[0 0];
    % %
    % %             while (abs(kold(1)-k(1))>0.1)
    % %                 kold(1) =k(1);
    % %                 k(1)= k(1) - (-numek1/denok1 + log(nume1/deno1)-log(k(1)) + psi(k(1)))/(psi(1,k(1))-1/k(1));
    % %             end
    % %
    % %             while (abs(kold(2)-k(2))>0.1)
    % %                 kold(2) =k(2);
    % %                 k(2)= k(2) - (-numek2/denok2  +log(nume2/deno2) -log(k(2))+psi(k(2)))/(psi(1,k(2))-1/k(2));
    % %             end
   
    theta(1)= nume1/(k(1)*deno1); %%%% CHECK CHECK CHECK !!!
    theta(2)= nume2/(k(2)*deno2);
    
    k
    theta
    
    %%%%%likelihood = log(sum(alpha(:,length(timeArray))))
    likelihood = -sum(log(scaling)) %%%%% What is going on here???????
    toc
end
